
package com.rc.retroweaver;

import java.io.*;
import java.util.*;

/**
 * Applies the RetroWeaver against a set of classes.
 *
 * @author Toby Reyelts
 *
 */
public class Weaver {

  public static void main( String[] args ) {
    File sourcePath = new File( args[ 0 ] );
    RetroWeaver weaver = new RetroWeaver();
    try {
      invokeWeaver( weaver, sourcePath );
    }
    catch ( Throwable t ) {
      t.printStackTrace();
    }
  }

  private static void invokeWeaver( RetroWeaver w, File path ) throws Exception {

    FileFilter filter = new FileFilter() {
      public boolean accept( File f ) {
        return f.isDirectory() || f.getName().endsWith( ".class" );
      }
    };

    File[] files = path.listFiles( filter );

    if ( files == null ) {
      files = new File[] {};
    }

    for ( int i = 0; i < files.length; ++i ) {
      File f = files[ i ];
      if ( f.isDirectory() ) {
        invokeWeaver( w, f );
        continue;
      }
      String pathStr = f.getCanonicalPath();
      w.weave( pathStr, null );
    }
  }
}

